import java.util.*;
public class equations {
	public static final Dimension distance = new Dimension(1,0,0);
	public static final Dimension time = new Dimension(0,1,0);
	public static final Dimension mass = new Dimension(0,0,1);
	
	public static final Dimension acceleration = new Dimension(1,-2,0);
	public static final Dimension velocity = new Dimension(1,-1,0);
	
	public static final Dimension pressureATM = new Dimension(-2,0,1);
	public static final Dimension volume = new Dimension(3,0,0);
	public static final Dimension moles = new Dimension(0,0,0);
	//public static final Dimension moles = new Dimension(0,0,0);
	
	
	//only 'real' member variable
	ArrayList Equations = new ArrayList();
	
	public equations(){
		Dimension d;
		//x = .5*a*t^2
		DimensionGroup distanceGivenAccelerationTime = new DimensionGroup("$1 squared " +
				"$0 times .5 times", "distance = (.5)*(acceleration)*(time)^2");
		distanceGivenAccelerationTime.add(acceleration);
		distanceGivenAccelerationTime.add(time);
		distanceGivenAccelerationTime.endResult = new Dimension(1, 0, 0);
		
		DimensionGroup accelerationGivenDistanceTime = new DimensionGroup("2 $0 times " +
				"$1 divide $1 divide", "acceleration = (distance * 2) / ((time)^2)");
		accelerationGivenDistanceTime.add(distance);
		accelerationGivenDistanceTime.add(time);
		accelerationGivenDistanceTime.endResult = new Dimension(1, -2, 0);
		
		DimensionGroup timeGivenAccelerationDistance = new DimensionGroup("2 $0 times " +
				"$1 divide squareRoot", "time = SQUAREROOT OF[ (distance * 2) / (acceleration) ]");
		timeGivenAccelerationDistance.add(distance);
		timeGivenAccelerationDistance.add(acceleration);
		timeGivenAccelerationDistance.endResult = new Dimension(0, 1, 0);
		
		//v[final] = a*t
		DimensionGroup velocityFGivenAccelerationTime = new DimensionGroup("$0 $1 " +
				"times", "velocity[final] = acceleration * time");
		velocityFGivenAccelerationTime.add(acceleration);
		velocityFGivenAccelerationTime.add(time);
		velocityFGivenAccelerationTime.endResult = new Dimension(1, -1, 0);
		
		DimensionGroup accelerationGivenVelocityFTime = new DimensionGroup("$0 $1 " +
				"divide", "acceleration = velocity[final] / time");
		accelerationGivenVelocityFTime.add(velocity);
		accelerationGivenVelocityFTime.add(time);
		accelerationGivenVelocityFTime.endResult = new Dimension(1, -2, 0);
		
		DimensionGroup timeGivenAccelerationVelocityF = new DimensionGroup("$0 $1 " +
				"divide", "time = velocity[final] / acceleration");
		timeGivenAccelerationVelocityF.add(velocity);
		timeGivenAccelerationVelocityF.add(acceleration);
		timeGivenAccelerationVelocityF.endResult = new Dimension(0, 1, 0);
		
		Equations.add(distanceGivenAccelerationTime);
		Equations.add(accelerationGivenDistanceTime);
		Equations.add(timeGivenAccelerationDistance);
		
		Equations.add(velocityFGivenAccelerationTime);
		Equations.add(accelerationGivenVelocityFTime);
		Equations.add(timeGivenAccelerationVelocityF);
		
	}
	
	public ArrayList getEquations(){
		return Equations;
	}
	
	public DimensionGroup lookAt(int index){
		if(this.Equations.size()<index || index<0)
			return null;
		else
			return ((DimensionGroup)this.Equations.get(index));
	}
	/*
	 * Precondition: given a Dimension, desired
	 * Postcondition: return an ArrayList of equations that have the same end result as desired
	 */
	public ArrayList fittedDimensionGroups(Dimension desired){
		ArrayList fit = new ArrayList();
		
		for(int index = 0; index<this.Equations.size(); index++){
			if(((DimensionGroup)(this.Equations.get(index))).endResult.equals(desired))
				fit.add(Equations.get(index));
		}
		
		return fit;
		
	}
	
	public String toString(){
		String total = "";
		
		for(int index = 0; index < Equations.size(); index++)
			total += (index+1) + ": " + ((DimensionGroup)Equations.get(index)).EQUinformation+ "\n";
		
		return total;
	}
}
